#include <stdio.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <termios.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/ioctl.h>

int open_pty_pair(int *amaster, int *aslave)
{
	int  master, slave;
	char *name;

	master = getpt ();
	if (master < 0) {
		return 0;
	}/* if (master < 0) */

	if (grantpt (master) < 0 || unlockpt (master) < 0) {
		goto close_master;
	}/* if (grantpt (master) < 0 || unlockpt (master) < 0) */
    
	name = (char *)ptsname (master);
	if (name == NULL) {
		goto close_master;
	}/* if (name == NULL) */

	slave = open (name, O_RDWR);
	if (slave == -1) {
		goto close_master;
	}/* if (slave == -1) */

	/* if (isastream (slave)) {
	if (ioctl (slave, I_PUSH, "ptem") < 0 || ioctl (slave, I_PUSH, "ldterm") < 0) {
		goto close_slave;
	}/* if (ioctl (slave, I_PUSH, "ptem") < 0 || ioctl (slave, I_PUSH, "ldterm") < 0)
	}if (isastream (slave)) */

	*amaster = master;
	*aslave = slave;
    
	return 1;

	close_slave:
		close (slave);

	close_master:
		close (master);
        
	return 0;
}/* open_pty_pair() */
